/*
 * Verrückte Turing-Maschinen — A turing complete game
 * Copyright (C) 2016-2018 kcf <vidofnir@folksprak.org>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

namespace lib_call
	{

		/**
		 * @author kcf <vidofnir@folksprak.org>
		 */
		export type type_complex<type_data> = {kind : string; data : type_data;};


		/**
		 * @author kcf <vidofnir@folksprak.org>
		 */
		export function wrap<type_data>(kind : string, data : type_data) : type_complex<type_data>
			{
				return {"kind": kind, "data": data};
			}


		/**
		 * @author kcf <vidofnir@folksprak.org>
		 */
		export function unwrap<type_data>(complex : type_complex<type_data>) : type_data
			{
				return complex.data;
			}


		/**
		 * @author kcf <vidofnir@folksprak.org>
		 */
		export function distinguish<type_result>
			(
				complex : type_complex<any>,
				cases : {[kind : string] : (data ?: any)=>type_result},
				fallback : (complex : type_complex<any>)=>type_result = ((complex) => {throw (new Error("unbehandelt"));})
			)
			: type_result
			{
				if (complex.kind in cases)
					{
						let function_ : (data ?: any)=>type_result = cases[complex.kind];
						let result : type_result = function_(complex.data);
						return result;
					}
				else
					{
						let message : string = ("unbehandelte Art '" + complex.kind + "'");
						console.warn(message);
						let result : type_result = fallback(complex);
						return result;
					}
			}
	}

